//////////////////////////////////////////////////////////////////////////
// define domains

domain='evpn.burble.dn42';
D(
    domain,
    REG_NONE,
    DnsProvider(PDNS),
    DefaultTTL(3600),
    NAMESERVER_TTL(86400),
    NAMESERVER('ns.de-fra1.evpn.burble.dn42.'),
    NAMESERVER('ns.us-nyc1.evpn.burble.dn42.')
);

//////////////////////////////////////////////////////////////////////////

D_EXTEND(
    domain,

    // nameservers
    AAAA('ns.de-fra1', 'fd42:4242:2601:331:72e8:bff:fe58:b51b'),
    AAAA('ns.us-nyc1', 'fd42:4242:2601:329:216:3eff:fe47:e097'),

    // BGP reflectors
    AAAA('reflector.de-fra1', 'fd42:4242:2601:331:216:3eff:fed5:85f2'),
    AAAA('reflector.us-nyc1', 'fd42:4242:2601:329:216:3eff:fed5:85f2'),

    // borg backup
    AAAA('borg.fr-par1', 'fd42:4242:2601:336:216:3eff:fe60:9eee'),    
    AAAA('borg.fr-par3', 'fd42:4242:2601:326:216:3eff:fe3f:e8d3'),
    AAAA('borg.uk-lon2', 'fd42:4242:2601:32e:216:3eff:febf:de10'),    
    CNAME('borg', 'borg.fr-par2.evpn.burble.dn42.')
)    


//////////////////////////////////////////////////////////////////////////
// hosts

// main nodes
nodes.forEach(function(n) {
    var hex = (n[4] + 32).toString(16);
    D_EXTEND(domain, AAAA(n[0], 'fd42:4242:2601:3'+hex+'::1'));
});

//////////////////////////////////////////////////////////////////////////
// end of file

